/*jslint vars: true, plusplus: true, devel: true, nomen: true, regexp: true, indent: 4, maxerr: 50 */
/*global $, Folder*/
app.preferences.rulerUnits = Units.PIXELS;
function checkSelection() {
    var docRef = app.activeDocument;
    var flag = true;
    try {
        docRef.selection.bounds;
    } catch (e) {
        flag = false;
    }
    return flag;
}

function createWrap(width){
    var docRef = app.activeDocument;
    if(!(isNaN(width))){
        if( checkSelection() ){
            var boundsObj = activeDocument.selection.bounds;
            var boundsWidth = parseInt(boundsObj[2]) - parseInt(boundsObj[0]);
            if( width < boundsWidth ){
                var left = boundsWidth/2 - width/2 + parseInt(boundsObj[0]);
                var right  = boundsWidth/2 + width/2 + parseInt(boundsObj[0]);
                guideWrap("Vrtc",left);
                guideWrap("Vrtc",right);
            }
        }else{
            var canvasWidth = docRef.width;
            if( width < canvasWidth){
                var left = canvasWidth/2 - width/2;
                var right  = canvasWidth/2 + width/2;
                guideWrap("Vrtc",left);
                guideWrap("Vrtc",right);
            }
        }
    }
}
function createCenterLine(VerticalBool,HorizonalBool){
    if( checkSelection() ){
        var boundsObj = activeDocument.selection.bounds;
        if( VerticalBool ){
            var boundsCenter = (parseInt(boundsObj[2])+parseInt(boundsObj[0]))/2;
            guideWrap("Vrtc",boundsCenter);
        }
        if( HorizonalBool ){
            var boundsCenter = (parseInt(boundsObj[3])+parseInt(boundsObj[1]))/2;
            guideWrap("Hrzn",boundsCenter);
        }
    }else{
        var docRef = app.activeDocument;
        if( VerticalBool ){
            var canvasCenter = docRef.width/2;
            guideWrap("Vrtc",canvasCenter);
        }
        if( HorizonalBool ){
            var canvasCenter = docRef.height/2;
            guideWrap("Hrzn",canvasCenter);
        }
    }
}

function createDivisionLine(division,gap,VerticalBool,HorizonalBool){
    if( checkSelection() ){
        var boundsObj = activeDocument.selection.bounds;
        if( VerticalBool ){
            var boundsWidth = parseInt(boundsObj[2])- parseInt(boundsObj[0]);
            if( gap > 0 ){
                var min = (boundsWidth - gap*(division - 1))/division;
                for( var i = 0; i < division + 1 ; i++ ){
                    if( i == 0 ){
                        var l = min*i + parseInt(boundsObj[0]);
                        guideWrap("Vrtc",l);
                    }else{
                        var l = min*i + gap*(i - 1) + parseInt(boundsObj[0]);
                        guideWrap("Vrtc",l);
                    }
                    if( i < division && 0 < i){
                        var g = min*i + parseInt(boundsObj[0]) + gap*i;
                        guideWrap("Vrtc",g);
                    }
                }
            }else{
                var min = boundsWidth/division;
                for( var i = 0; i < division + 1 ; i++ ){
                    var l = min*i + parseInt(boundsObj[0]);
                    guideWrap("Vrtc",l);
                }
            }
            guideWrap("Vrtc",parseInt(boundsObj[2]));
        }
        if( HorizonalBool ){
            var boundsHeight = parseInt(boundsObj[3]) - parseInt(boundsObj[1]);
            if( gap > 0 ){
                var min = (boundsHeight - gap*(division - 1))/division;
                for( var i = 0; i < division + 1 ; i++ ){
                    if( i == 0 ){
                        var l = min*i + parseInt(boundsObj[1]);
                        guideWrap("Hrzn",l);
                    }else{
                        var l = min*i + gap*(i - 1)+ parseInt(boundsObj[1]);
                        guideWrap("Hrzn",l);
                    }
                    if( i < division && 0 < i){
                        var g = min*i + parseInt(boundsObj[1]) + gap*i;
                        guideWrap("Hrzn",g);
                    }
                }
            }else{
                var min = boundsHeight/division;
                for( var i = 0; i < division + 1 ; i++ ){
                    var l = min*i + parseInt(boundsObj[1]);
                    guideWrap("Hrzn",l);
                }
            }
            guideWrap("Hrzn",parseInt(boundsObj[3]));
        }
    }else{
        var docRef = app.activeDocument;
        if( VerticalBool ){
            var boundsWidth = docRef.width;
            if( gap > 0 ){
                var min = (boundsWidth - gap*(division - 1))/division;
                for( var i = 0; i < division + 1 ; i++ ){
                    if( i == 0 ){
                        var l = min*i ;
                        guideWrap("Vrtc",l);
                    }else{
                        var l = min*i + gap*(i - 1);
                        guideWrap("Vrtc",l);
                    }
                    if( i < division && 0 < i){
                        var g = min*i + gap*i;
                        guideWrap("Vrtc",g);
                    }
                }
            }else{
                var min = boundsWidth/division;
                for( var i = 0; i < division + 1 ; i++ ){
                    var l = min*i;
                    guideWrap("Vrtc",l);
                }
            }
            guideWrap("Vrtc",boundsWidth);
        }
        if( HorizonalBool ){
            var boundsHeight = docRef.height;
            if( gap > 0 ){
                var min = (boundsHeight - gap*(division - 1))/division;
                for( var i = 0; i < division + 1 ; i++ ){
                    if( i == 0 ){
                        var l = min*i ;
                        guideWrap("Hrzn",l);
                    }else{
                        var l = min*i + gap*(i - 1);
                        guideWrap("Hrzn",l);
                    }
                    if( i < division && 0 < i){
                        var g = min*i + gap*i;
                        guideWrap("Hrzn",g);
                    }
                }
            }else{
                var min = boundsHeight/division;
                for( var i = 0; i < division + 1 ; i++ ){
                    var l = min*i ;
                    guideWrap("Hrzn",l);
                }
            }
            guideWrap("Hrzn",boundsHeight);
        }
    }
}

function createMeshLine(meshWidth,meshHeight){
    var x1;
    var x2;
    var y1;
    var y2;
    if( checkSelection() ){
        var boundsObj = activeDocument.selection.bounds;
        x1 = parseInt(boundsObj[0]);
        y1 = parseInt(boundsObj[1]);
        x2 = parseInt(boundsObj[2]);
        y2 = parseInt(boundsObj[3]);
    }else{
        var docRef = app.activeDocument;
        x1 = 0;
        y1 = 0;
        x2 = docRef.width;
        y2 = docRef.height;
    }
    if( meshWidth != 0 ){
        for( var l = x1 ; l <= x2 ; l += meshWidth){
            guideWrap("Vrtc",l);
        }

    }
    if( meshHeight != 0 ){
        for( var m = y1 ; m <= y2 ; m += meshHeight){
            guideWrap("Hrzn",m);
        }
    }
}

function createTop(top){
    if( checkSelection() ){
        var boundsObj = activeDocument.selection.bounds;
        var l = parseInt(boundsObj[1]) + top;
        guideWrap("Hrzn",l);
    }else{
        guideWrap("Hrzn",top);
    }
}
function createBottom(bottom){
    if( checkSelection() ){
        var boundsObj = activeDocument.selection.bounds;
        var l = parseInt(boundsObj[3]) + (-1)*bottom;
        guideWrap("Hrzn",l);
    }else{
        var docRef = app.activeDocument;
        var l = docRef.height + (-1)*bottom;
        guideWrap("Hrzn",l);
    }
}
function createLeft(left){
    if( checkSelection() ){
        var boundsObj = activeDocument.selection.bounds;
        var l = parseInt(boundsObj[0]) + left;
        guideWrap("Vrtc",l);
    }else{
        guideWrap("Vrtc",left);
    }
}
function createRight(right){
    if( checkSelection() ){
        var boundsObj = activeDocument.selection.bounds;
        var l = parseInt(boundsObj[2]) + (-1)*right;
        guideWrap("Vrtc",l);
    }else{
        var docRef = app.activeDocument;
        var l = docRef.width + (-1)*right;
        guideWrap("Vrtc",l);
    }
}

function guideWrap(direction,position){
    var id1 = charIDToTypeID( "Mk  " );
        var desc1 = new ActionDescriptor();
        var id2 = charIDToTypeID( "Nw  " );
            var desc2 = new ActionDescriptor();
            var id3 = charIDToTypeID( "Pstn" );
            var id4 = charIDToTypeID( "#Pxl" );
            desc2.putUnitDouble( id3, id4, position );
            var id5 = charIDToTypeID( "Ornt" );
            var id6 = charIDToTypeID( "Ornt" );
            var id7 = charIDToTypeID( direction );
            desc2.putEnumerated( id5, id6, id7 );
        var id8 = charIDToTypeID( "Gd  " );
        desc1.putObject( id2, id8, desc2 );
    executeAction(id1,desc1,DialogModes.NO);
}