window.addEventListener('load',(()=>{
  'use strict';
  const csInterface = new CSInterface();
  themeManager.init();
  const wrapwidthBtn = document.getElementById("wrapwidthBtn");
  wrapwidthBtn.addEventListener("click",(()=>{
    const wrapwidth = document.getElementById("wrapwidth").value;
    csInterface.evalScript(`createWrap(${wrapwidth})`);
  }));

  const centerLine = document.getElementById("centerLine");
  centerLine.addEventListener("click",(()=>{
    const VerticalBool = document.getElementsByName("centerLineDirV")[0].checked;
    const HorizonalBool = document.getElementsByName("centerLineDirH")[0].checked;
    csInterface.evalScript(`createCenterLine(${VerticalBool},${HorizonalBool})`);
  }));

  const divisionLine = document.getElementById("divisionLine");
  divisionLine.addEventListener("click",(()=>{
    const VerticalBool = document.getElementsByName("divisionDirV")[0].checked;
    const HorizonalBool = document.getElementsByName("divisionDirH")[0].checked;
    let divsion = document.getElementsByName("division")[0].value;
    divsion = parseInt(divsion);
    let gap = document.getElementsByName("divisionGap")[0].value;
    gap = parseInt(gap);
    if(isNaN(divsion) || divsion <= 0){
      divsion = 1;
    }
    if( isNaN(gap) || gap <= 0){
      gap = 0;
    }
    csInterface.evalScript(`createDivisionLine(${divsion},${gap},${VerticalBool},${HorizonalBool})`);
  }));

  const meshLine = document.getElementById("meshLine");
  meshLine.addEventListener("click",(()=>{
    let meshWidth = document.getElementsByName("meshWidth")[0].value;
    let meshHeight = document.getElementsByName("meshHeight")[0].value;
    meshWidth = parseInt(meshWidth);
    meshHeight = parseInt(meshHeight);
    if( !(isNaN(meshHeight)) && meshHeight > 0 && !(isNaN(meshWidth)) && meshWidth > 0){
      csInterface.evalScript(`createMeshLine(${meshWidth},${meshHeight})`);
    }else if(!(isNaN(meshHeight)) && meshHeight > 0 ){
      csInterface.evalScript(`createMeshLine(0,${meshHeight})`);
    }else if(!(isNaN(meshWidth)) && meshWidth > 0 ){
      csInterface.evalScript(`createMeshLine(${meshWidth},0)`);
    }
  }));

  const paddingLine = document.getElementById("paddingLine");
  paddingLine.addEventListener("click",(()=>{
    let top = document.getElementsByName("paddingtop")[0].value;
    let bottom = document.getElementsByName("paddingbottom")[0].value;
    let left = document.getElementsByName("paddingleft")[0].value;
    let right = document.getElementsByName("paddingright")[0].value;
    top = parseInt(top);
    bottom = parseInt(bottom);
    left = parseInt(left);
    right = parseInt(right);
    if( !(isNaN(top)) ){
      csInterface.evalScript(`createTop(${top})`);
    }
    if( !(isNaN(bottom)) ){
      csInterface.evalScript(`createBottom(${bottom})`);
    }
    if( !(isNaN(left)) ){
      csInterface.evalScript(`createLeft(${left})`);
    }
    if( !(isNaN(right)) ){
      csInterface.evalScript(`createRight(${right})`);
    }

  }));

}),false);